package cn.fw.hermes.common.constant;

import lombok.Getter;

/**
 * @author 张志伟
 * @date 2018-09-20 10:39
 * @description
 */
public enum ProfileTagEnum {
    /**
     * 资料字段
     */
    NIKE("Tag_Profile_IM_Nick", "昵称"),
    GENDER("Tag_Profile_IM_Gender", "性别"),
    BIRTHDAY("Tag_Profile_IM_BirthDay", "生日"),
    LOCATION("Tag_Profile_IM_Location", "地理位置"),
    SIG("Tag_Profile_IM_SelfSignature", "个性签名"),
    ALLOW_TYPE("Tag_Profile_IM_AllowType", "好友验证方式"),
    LANGUAGE("Tag_Profile_IM_Language", "语言"),
    IMAGE("Tag_Profile_IM_Image", "头像"),
    MSG_SETTINGS("Tag_Profile_IM_MsgSettings", "消息设置"),
    ADMIN_FORBID_TYPE("Tag_Profile_IM_AdminForbidType", "管理员禁止加好友标识"),
    LEVEL("Tag_Profile_IM_Level", "等级"),
    ROLE("Tag_Profile_IM_Role", "角色");

    @Getter
    private String code;
    @Getter
    private String msg;

    ProfileTagEnum(String code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public static ProfileTagEnum getEnum(String code) {
        for (ProfileTagEnum profileTagEnum : ProfileTagEnum.values()) {
            if (code.equals(profileTagEnum.getCode())) {
                return profileTagEnum;
            }
        }
        throw new IllegalArgumentException(code + "没有对应枚举");
    }
}
