package cn.fw.hermes.common.utils;

import lombok.Getter;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

/**
 * 连接池配置类
 *
 * @author Kurisu
 */
@Component
public class HttpClientPoolConfig {
    /**
     * 默认content 类型
     */
    @Value("${http_default_content_type}")
    @Getter
    private String defaultContentType;
    /**
     *
     */
    @Value("${http_default_accept}")
    @Getter
    private String defaultAccept;
    /**
     * 默认请求超时时间30s
     */
    @Value("${http_default_timeout}")
    @Getter
    private int defaultTimeOut;
    /**
     * 每个路由基础连接数
     */
    @Value("${http_default_per_route}")
    @Getter
    private int perRoute;
    /**
     * 每个路由最大连接数
     */
    @Value("${http_max_per_route}")
    @Getter
    private int maxPerRoute;
    /**
     * 最大连接数
     */
    @Value("${http_default_total_count}")
    @Getter
    private int totalCount;

    /**
     * 连接超时时间
     */
    @Value("${http_default_keep_time}")
    @Getter
    private int httpDefaultKeepTime;
}