package cn.fw.hermes.domain.db;

import cn.fw.common.data.entity.BaseEntity;
import cn.fw.data.base.db.annotation.DbTable;
import lombok.Data;

import java.util.Date;

/**
 *
 *
 * @Author: liwei
 * @Date: 2018/12/10 19:51
 */
@Data
@DbTable("chat_pull_record")
public class ChatPullRecord extends BaseEntity<ChatPullRecord, Long> {

    /**
     * 拉取的日期和小时   比如  2018121019 表示2018-12-10 19:00:00~19:59:59
     * 每小时拉取
     */
    private String pullTime;
    /**
     * 创建时间
     */
    private Date createTime;
    /**
     * 腾讯code  有 "0" 表示正常且有数据
     * 1004表示正常但无数据  (需要重试)
     */
    private Integer txCode;
    /**
     * 腾讯code说明
     */
    private String txMsg;

    public static ChatPullRecord create(String dayHour,
                                        Date createTime,
                                        Integer txCode,
                                        String txMsg) {
        ChatPullRecord result = new ChatPullRecord();
        result.setPullTime(dayHour);
        result.setCreateTime(createTime);
        result.setTxCode(txCode);
        result.setTxMsg(txMsg);
        return result;
    }
}
