package cn.fw.hermes.service.data.impl;

import cn.fw.hermes.dao.mapper.ChatRecordMapper;
import cn.fw.hermes.domain.db.ChatRecord;
import cn.fw.hermes.sdk.api.result.ChatUserDto;
import cn.fw.hermes.service.data.ChatRecordService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import java.util.Date;
import org.springframework.stereotype.Service;
import java.util.List;
import org.springframework.transaction.annotation.Transactional;


/**
 * @Author: Chenery
 * @Date: 2021/2/21 9:14
 */
@Service
public class ChatRecordServiceImpl extends ServiceImpl<ChatRecordMapper, ChatRecord> implements
        ChatRecordService {

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean insertBatch(List<ChatRecord> recordList) {
        return this.saveBatch(recordList);
    }

    @Override
    public List<ChatUserDto> queryNumberOfChat(Integer chatCount, List<Integer> userTypes,
            Date startTime, Date endTime) {
        return getBaseMapper().queryNumberOfChat(chatCount, userTypes, startTime, endTime);
    }
}
